require 'net/http'
require 'rexml/document'
require 'tweet'

# Read tweets from the user's timeilne one at a time
#
class Reader

  def initialize
    @user, @password = ENV['TWITTER_USER'], ENV['TWITTER_PASS']
    @uri = URI.parse 'http://twitter.com/statuses/user_timeline.xml'
    @buffer = []
    @max_id = nil
  end

  def next
    refresh if @buffer.empty?
    @buffer.shift
  end

  private 

  def refresh
    request = "#{@uri.path}"
    request += "?max_id=#{@max_id - 1}" if @max_id
    request = Net::HTTP::Get.new(request)
    request.basic_auth(@user, @password)
    http = Net::HTTP.new(@uri.host, @uri.port)
    response = nil
    http.start do |connection|
      response = connection.request(request)
      if !response.kind_of? Net::HTTPSuccess
        raise SecurityError.new(response.body) 
      end
    end
    d = REXML::Document.new(response.body)
    statuses = REXML::XPath.match(d, '//status')
    @buffer = statuses.map {|s| Tweet.new(s)}
    @max_id = @buffer[-1].t_id
  end

end
